unit JetButtonEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UjetButton, ExtCtrls, StdCtrls, Buttons, ExtDlgs, Registry, PicClip;

type
  TfrmJetButtonEditor = class(TForm)
    Panel1: TPanel;
    IDown: TImage;
    Label1: TLabel;
    LDown: TSpeedButton;
    Bevel1: TBevel;
    SpeedButton2: TSpeedButton;
    CBDown: TCheckBox;
    Panel2: TPanel;
    IDisabled: TImage;
    Label2: TLabel;
    LDisabled: TSpeedButton;
    Bevel2: TBevel;
    SpeedButton4: TSpeedButton;
    CBDisabled: TCheckBox;
    Panel4: TPanel;
    IUP: TImage;
    Label4: TLabel;
    LUp: TSpeedButton;
    Bevel4: TBevel;
    SpeedButton8: TSpeedButton;
    CBUp: TCheckBox;
    Panel5: TPanel;
    IOver: TImage;
    Label5: TLabel;
    LOver: TSpeedButton;
    Bevel5: TBevel;
    SpeedButton10: TSpeedButton;
    CBOver: TCheckBox;
    BitBtn1: TBitBtn;
    Label6: TLabel;
    BitBtn2: TBitBtn;
    SEnabled: TSpeedButton;
    Edit1: TEdit;
    Label7: TLabel;
    SpeedButton12: TSpeedButton;
    OpenD: TOpenPictureDialog;
    FontD: TFontDialog;
    I1: TImage;
    I2: TImage;
    JSample: TJetButton;
    SBackGround: TSpeedButton;
    IHatter: TImage;
    SBClear: TSpeedButton;
    SPic: TSpeedButton;
    SSBack: TSpeedButton;
    procedure FormActivate(Sender: TObject);
    procedure LDownClick(Sender: TObject);
    procedure LDisabledClick(Sender: TObject);
    procedure LUpClick(Sender: TObject);
    procedure LOverClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure CBDownClick(Sender: TObject);
    procedure CBDisabledClick(Sender: TObject);
    procedure CBUpClick(Sender: TObject);
    procedure CBOverClick(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure SEnabledClick(Sender: TObject);
    procedure FontDApply(Sender: TObject; Wnd: Integer);
    procedure IUPClick(Sender: TObject);
    procedure SBackGroundClick(Sender: TObject);
    procedure SBClearClick(Sender: TObject);
    procedure SSBackClick(Sender: TObject);
    procedure SPicClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    PClip: TPicClip;
    FPicSeries: String;
    procedure PictureRefresh;
    { Public declarations }
  end;

implementation

{$R *.DFM}

function ExtractFieldName(const Fields: string; var Pos: Integer): string;
var
  I: Integer;
begin
  I := Pos;
  while (I <= Length(Fields)) and (Fields[I] <> ';') do Inc(I);
  Result := Trim(Copy(Fields, Pos, I - Pos));
  if (I <= Length(Fields)) and (Fields[I] = ';') then Inc(I);
  Pos := I;
end;

procedure TfrmJetButtonEditor.PictureRefresh;
begin
  With JSample do begin
    BitmapUp.Assign(IUp.Picture.Bitmap);
    BitmapOver.Assign(IOver.Picture.BitMap);
    BitmapDown.Assign(IDown.Picture.BitMap);
    BitmapDisabled.Assign(IDisabled.Picture.BitMap);
    Invalidate;
  end;
end;

procedure TfrmJetButtonEditor.FormActivate(Sender: TObject);
Var Reg: TRegistry;
begin
  Edit1.SetFocus;
  SEnabledClick(Sender);
  JSample.Font.Assign(FontD.Font);
  SPic.Enabled:=(Assigned(PClip)) and (PClip<>nil) and (PClip.Picture<>nil) and (FPicSeries<>'');
  Reg:=TRegistry.Create;
  Try
    Reg.OpenKey('Delphi\JetButton',True);
    SSBack.Enabled:=False;
    If Reg.ValueExists('BackgroundPicture') then begin
      If Reg.ReadString('BackgroundPicture')<>'' then begin
        IHatter.Picture.LoadFromFile(Reg.ReadString('BackgroundPicture'));
        SSBack.Enabled:=True;
      end;
    end
    else Reg.WriteString('BackgroundPicture','');
    Reg.CloseKey;
  Except
    SBClearClick(Sender);
  End;
  Reg.Free;
end;

procedure TfrmJetButtonEditor.LUpClick(Sender: TObject);
begin
  IUpClick(IUp);
end;

procedure TfrmJetButtonEditor.LDownClick(Sender: TObject);
begin
  IUpClick(IDown);
end;

procedure TfrmJetButtonEditor.LDisabledClick(Sender: TObject);
begin
  IUpClick(IDisabled);
end;

procedure TfrmJetButtonEditor.LOverClick(Sender: TObject);
begin
  IUpClick(IOver);
end;

procedure TfrmJetButtonEditor.SpeedButton2Click(Sender: TObject);
begin
  IDown.Picture:=nil;
  CBDown.Checked:=False;
  PictureRefresh;
end;

procedure TfrmJetButtonEditor.SpeedButton4Click(Sender: TObject);
begin
  IDisabled.Picture:=nil;
  CBDisabled.Checked:=False;
  PictureRefresh;
end;

procedure TfrmJetButtonEditor.SpeedButton8Click(Sender: TObject);
begin
  IUp.Picture:=nil;
  CBUp.Checked:=False;
  PictureRefresh;
end;

procedure TfrmJetButtonEditor.SpeedButton10Click(Sender: TObject);
begin
  IOver.Picture:=nil;
  CBOver.Checked:=False;
  PictureRefresh;
end;

procedure TfrmJetButtonEditor.CBDownClick(Sender: TObject);
begin
  IDown.Stretch:=(Sender as TCheckBox).Checked;
end;

procedure TfrmJetButtonEditor.CBDisabledClick(Sender: TObject);
begin
  IDisabled.Stretch:=(Sender as TCheckBox).Checked;
end;

procedure TfrmJetButtonEditor.CBUpClick(Sender: TObject);
begin
  IUp.Stretch:=(Sender as TCheckBox).Checked;
end;

procedure TfrmJetButtonEditor.CBOverClick(Sender: TObject);
begin
  IOver.Stretch:=(Sender as TCheckBox).Checked;
end;

procedure TfrmJetButtonEditor.SpeedButton12Click(Sender: TObject);
begin
  IF FontD.Execute then JSample.Font.Assign(FontD.Font);
end;

procedure TfrmJetButtonEditor.Edit1Change(Sender: TObject);
begin
  JSample.Caption:=Edit1.Text;
end;

procedure TfrmJetButtonEditor.SEnabledClick(Sender: TObject);
begin
  JSample.Enabled:=not SEnabled.Down;
  IF SEnabled.Down then SEnabled.Glyph.Assign(I2.Picture.Bitmap)
  else SEnabled.Glyph.Assign(I1.Picture.Bitmap);
end;


procedure TfrmJetButtonEditor.FontDApply(Sender: TObject; Wnd: Integer);
begin
  JSample.Font.Assign(FontD.Font);
end;

procedure TfrmJetButtonEditor.IUPClick(Sender: TObject);
begin
  OpenD.Filter:='Bitmaps (*.bmp)|*.BMP|All file (*.*)|*.*';
  If OpenD.Execute then (Sender as TImage).Picture.LoadFromFile(OpenD.FileName);
  PictureRefresh;
end;


procedure TfrmJetButtonEditor.SBackGroundClick(Sender: TObject);
Var Reg: Tregistry;
begin
  Reg:=TRegistry.Create;
  Reg.OpenKey('Delphi\JetButton',True);
  Try
    Try
      OpenD.InitialDir:=ExtractFilePath(Reg.ReadString('BackgroundPicture'));
    Except
      Reg.WriteString('BackgroundPicture','');
    End;
    OpenD.Filter:='All (*.jpg;*.jpeg;*.dib;*.bmp;*.ico;*.emf;*.wmf)|*.jpg;*.jpeg;'+
                  '*.dib;*.bmp;*.ico;*.emf;*.wmf|JPEG Image File (*.jpg)|*.jpg|JPEG Image File (*.jpeg)|*.jpeg|Device Independent Bitmap (*.dib)|*.dib|Bitmaps (*.bmp)|*.bmp|Icons (*.ico)|*.ico|Enhanced Metafiles (*.emf)|*.emf|Metafiles (*.wmf)|*.wmf';
    If OpenD.Execute then begin
      IHatter.Picture.LoadFromFile(OpenD.FileName);
      SSBack.Enabled:=Assigned(IHatter.Picture);
      Reg.WriteString('BackgroundPicture',OpenD.FileName);
    end;
  Finally
    Reg.CloseKey;
    Reg.Free;
  end;
end;

procedure TfrmJetButtonEditor.SBClearClick(Sender: TObject);
Var Reg: TRegistry;
begin
  IHatter.Picture:=nil;
  SSBack.Enabled:=False;
  Reg:=TRegistry.Create;
  Try
    Reg.OpenKey('Delphi\JetButton',True);
    Reg.WriteString('BackgroundPicture','');
    Reg.CloseKey;
  Finally
    Reg.Free;
  end;
end;

procedure TfrmJetButtonEditor.SSBackClick(Sender: TObject);
begin
  IHatter.Stretch:=SSBack.Down;
end;

procedure TfrmJetButtonEditor.SPicClick(Sender: TObject);
Var X,Count: Integer;
    S: String;
begin
  X:=1;
  Count:=1;
  while X<=Length(FPicSeries) do begin
    S:=AnsiUpperCase(ExtractFieldName(FPicSeries,X));
    If Count<=PClip.Cols then begin
      If (S='UP') then IUp.Picture.Bitmap.Assign(PClip.GraphicCell[Count-1]);
      If (S='DISABLED') then IDisabled.Picture.Bitmap.Assign(PClip.GraphicCell[Count-1]);
      If (S='DOWN') then IDown.Picture.Bitmap.Assign(PClip.GraphicCell[Count-1]);
      If (S='OVER') then IOver.Picture.Bitmap.Assign(PClip.GraphicCell[Count-1]);
    end;
    Inc(Count);
  end;
  PictureRefresh;
end;

procedure TfrmJetButtonEditor.FormDestroy(Sender: TObject);
begin
  PClip:=nil;
end;

end.
