unit JetCheckBoxEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UjetButton, ExtCtrls, StdCtrls, Buttons, UJetCheckBox, ExtDlgs, Registry, PicClip;

type
  TfrmJetCheckBoxEditor = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    Bevel1: TBevel;
    SpeedButton2: TSpeedButton;
    CheckBox1: TCheckBox;
    Panel2: TPanel;
    Image2: TImage;
    Label2: TLabel;
    SpeedButton3: TSpeedButton;
    Bevel2: TBevel;
    SpeedButton4: TSpeedButton;
    CheckBox2: TCheckBox;
    Panel3: TPanel;
    Image3: TImage;
    Label3: TLabel;
    SpeedButton5: TSpeedButton;
    Bevel3: TBevel;
    SpeedButton6: TSpeedButton;
    CheckBox3: TCheckBox;
    Panel4: TPanel;
    Image4: TImage;
    Label4: TLabel;
    SpeedButton7: TSpeedButton;
    Bevel4: TBevel;
    SpeedButton8: TSpeedButton;
    CheckBox4: TCheckBox;
    Panel5: TPanel;
    Image5: TImage;
    Label5: TLabel;
    SpeedButton9: TSpeedButton;
    Bevel5: TBevel;
    SpeedButton10: TSpeedButton;
    CheckBox5: TCheckBox;
    JButton: TJetCheckBox;
    BitBtn1: TBitBtn;
    Label6: TLabel;
    BitBtn2: TBitBtn;
    SEnabled: TSpeedButton;
    Edit1: TEdit;
    Label7: TLabel;
    SpeedButton12: TSpeedButton;
    OpenD: TOpenPictureDialog;
    FontD: TFontDialog;
    I1: TImage;
    I2: TImage;
    SBackGround: TSpeedButton;
    SBClear: TSpeedButton;
    IHatter: TImage;
    SPic: TSpeedButton;
    SSBack: TSpeedButton;
    procedure FormActivate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure SEnabledClick(Sender: TObject);
    procedure FontDApply(Sender: TObject; Wnd: Integer);
    procedure SBackGroundClick(Sender: TObject);
    procedure SBClearClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SPicClick(Sender: TObject);
    procedure SSBackClick(Sender: TObject);
  private
    { Private declarations }
  public
    PClip: TPicClip;
    FPicSeries: String;
    procedure PictureRefresh;
    { Public declarations }
  end;

implementation

{$R *.DFM}

function ExtractFieldName(const Fields: string; var Pos: Integer): string;
var
  I: Integer;
begin
  I := Pos;
  while (I <= Length(Fields)) and (Fields[I] <> ';') do Inc(I);
  Result := Trim(Copy(Fields, Pos, I - Pos));
  if (I <= Length(Fields)) and (Fields[I] = ';') then Inc(I);
  Pos := I;
end;

procedure TfrmJetCheckBoxEditor.PictureRefresh;
begin
  JButton.BitmapChecked.Assign(Image1.Picture.Bitmap);
  JButton.BitmapOverChecked.Assign(Image2.Picture.Bitmap);
  JButton.BitmapDisabled.Assign(Image3.Picture.Bitmap);
  JButton.BitmapUnChecked.Assign(Image4.Picture.Bitmap);
  JButton.BitmapOverUnChecked.Assign(Image5.Picture.Bitmap);
  JButton.Invalidate;
end;

procedure TfrmJetCheckBoxEditor.FormActivate(Sender: TObject);
Var Reg: TRegistry;
begin
  Edit1.SetFocus;
  SEnabledClick(Sender);
  JButton.Font.Assign(FontD.Font);
  Reg:=TRegistry.Create;
  SPic.Enabled:=(Assigned(PClip)) and (PClip<>nil) and (PClip.Picture<>nil) and (FPicSeries<>'');
  Try
    Reg.OpenKey('Delphi\JetCheckBox',True);
    SSBack.Enabled:=False;
    If Reg.ValueExists('BackgroundPicture') then begin
      If Reg.ReadString('BackgroundPicture')<>'' then begin
        IHatter.Picture.LoadFromFile(Reg.ReadString('BackgroundPicture'));
        SSBack.Enabled:=True;
      end;
    end
    else Reg.WriteString('BackgroundPicture','');
    Reg.CloseKey;
  Except
    SBClearClick(Sender);
  End;
  Reg.Free;
end;

procedure TfrmJetCheckBoxEditor.SpeedButton1Click(Sender: TObject);
begin
  Image1Click(Image1);
end;

procedure TfrmJetCheckBoxEditor.Image1Click(Sender: TObject);
begin
  OpenD.Filter:='Bitmaps (*.bmp)|*.BMP|All file (*.*)|*.*';
  If OpenD.Execute then (Sender as TImage).Picture.LoadFromFile(OpenD.FileName);
  PictureRefresh;
end;

procedure TfrmJetCheckBoxEditor.SpeedButton3Click(Sender: TObject);
begin
  Image1Click(Image2);
end;

procedure TfrmJetCheckBoxEditor.SpeedButton5Click(Sender: TObject);
begin
  Image1Click(Image3);
end;

procedure TfrmJetCheckBoxEditor.SpeedButton7Click(Sender: TObject);
begin
  Image1Click(Image4);
end;

procedure TfrmJetCheckBoxEditor.SpeedButton9Click(Sender: TObject);
begin
  Image1Click(Image5);
end;

procedure TfrmJetCheckBoxEditor.SpeedButton2Click(Sender: TObject);
begin
  Image1.Picture:=nil;
  CheckBox1.Checked:=False;
  PictureRefresh;
end;

procedure TfrmJetCheckBoxEditor.SpeedButton4Click(Sender: TObject);
begin
  Image2.Picture:=nil;
  CheckBox2.Checked:=False;
  PictureRefresh;
end;

procedure TfrmJetCheckBoxEditor.SpeedButton6Click(Sender: TObject);
begin
  Image3.Picture:=nil;
  CheckBox3.Checked:=False;
  PictureRefresh;
end;

procedure TfrmJetCheckBoxEditor.SpeedButton8Click(Sender: TObject);
begin
  Image4.Picture:=nil;
  CheckBox4.Checked:=False;
  PictureRefresh;
end;

procedure TfrmJetCheckBoxEditor.SpeedButton10Click(Sender: TObject);
begin
  Image5.Picture:=nil;
  CheckBox5.Checked:=False;
  PictureRefresh;
end;

procedure TfrmJetCheckBoxEditor.CheckBox1Click(Sender: TObject);
begin
  Image1.Stretch:=CheckBox1.Checked;
end;

procedure TfrmJetCheckBoxEditor.CheckBox2Click(Sender: TObject);
begin
  Image2.Stretch:=CheckBox2.Checked;
end;

procedure TfrmJetCheckBoxEditor.CheckBox3Click(Sender: TObject);
begin
  Image3.Stretch:=CheckBox3.Checked;
end;

procedure TfrmJetCheckBoxEditor.CheckBox4Click(Sender: TObject);
begin
  Image4.Stretch:=CheckBox4.Checked;
end;

procedure TfrmJetCheckBoxEditor.CheckBox5Click(Sender: TObject);
begin
  Image5.Stretch:=CheckBox5.Checked;
end;

procedure TfrmJetCheckBoxEditor.SpeedButton12Click(Sender: TObject);
begin
  IF FontD.Execute then JButton.Font.Assign(FontD.Font);
end;

procedure TfrmJetCheckBoxEditor.Edit1Change(Sender: TObject);
begin
  JButton.Caption:=Edit1.Text;
end;

procedure TfrmJetCheckBoxEditor.SEnabledClick(Sender: TObject);
begin
  JButton.Enabled:=not SEnabled.Down;
  IF SEnabled.Down then SEnabled.Glyph.Assign(I2.Picture.Bitmap)
  else SEnabled.Glyph.Assign(I1.Picture.Bitmap);
end;

procedure TfrmJetCheckBoxEditor.FontDApply(Sender: TObject; Wnd: Integer);
begin
  JButton.Font.Assign(FontD.Font);
end;

procedure TfrmJetCheckBoxEditor.SBackGroundClick(Sender: TObject);
Var Reg: Tregistry;
begin
  Reg:=TRegistry.Create;
  Reg.OpenKey('Delphi\JetCheckBox',True);
  Try
    Try
      OpenD.InitialDir:=ExtractFilePath(Reg.ReadString('BackgroundPicture'));
    Except
      Reg.WriteString('BackgroundPicture','');
    End;
    OpenD.Filter:='All (*.jpg;*.jpeg;*.dib;*.bmp;*.ico;*.emf;*.wmf)|*.jpg;*.jpeg;'+
                  '*.dib;*.bmp;*.ico;*.emf;*.wmf|JPEG Image File (*.jpg)|*.jpg|JPEG Image File (*.jpeg)|*.jpeg|Device Independent Bitmap (*.dib)|*.dib|Bitmaps (*.bmp)|*.bmp|Icons (*.ico)|*.ico|Enhanced Metafiles (*.emf)|*.emf|Metafiles (*.wmf)|*.wmf';
    If OpenD.Execute then begin
      IHatter.Picture.LoadFromFile(OpenD.FileName);
      SSBack.Enabled:=Assigned(IHatter.Picture);
      Reg.WriteString('BackgroundPicture',OpenD.FileName);
    end;
  Finally
    Reg.CloseKey;
    Reg.Free;
  end;
end;

procedure TfrmJetCheckBoxEditor.SBClearClick(Sender: TObject);
Var Reg: TRegistry;
begin
  IHatter.Picture:=nil;
  SSBack.Enabled:=False;
  Reg:=TRegistry.Create;
  Try
    Reg.OpenKey('Delphi\JetCheckBox',True);
    Reg.WriteString('BackgroundPicture','');
    Reg.CloseKey;
  Finally
    Reg.Free;
  end;
end;


procedure TfrmJetCheckBoxEditor.FormDestroy(Sender: TObject);
begin
  PClip:=nil;
end;

procedure TfrmJetCheckBoxEditor.SPicClick(Sender: TObject);
Var X,Count: Integer;
    S: String;
begin
  X:=1;
  Count:=1;
  while X<=Length(FPicSeries) do begin
    S:=AnsiUpperCase(ExtractFieldName(FPicSeries,X));
    If Count<=PClip.Cols then begin
      If (S='UNCHECKED') then Image4.Picture.Bitmap.Assign(PClip.GraphicCell[Count-1]);
      If (S='DISABLED') then Image3.Picture.Bitmap.Assign(PClip.GraphicCell[Count-1]);
      If (S='CHECKED') then Image1.Picture.Bitmap.Assign(PClip.GraphicCell[Count-1]);
      If (S='OVERUNCHECKED') then Image5.Picture.Bitmap.Assign(PClip.GraphicCell[Count-1]);
      If (S='OVERCHECKED') then Image2.Picture.Bitmap.Assign(PClip.GraphicCell[Count-1]);
    end;
    Inc(Count);
  end;
  PictureRefresh;
end;



procedure TfrmJetCheckBoxEditor.SSBackClick(Sender: TObject);
begin
  IHatter.Stretch:=SSBack.Down;
end;

end.
