unit JetReg;

interface

procedure Register;

implementation

Uses UJetButton, UJetAnimButton, UJetCheckBox, JetCheckBoxEditor, JetButtonEditor, DsgnIntf, stdctrls, Buttons,
     Classes, SysUtils, Controls, Graphics, ExtCtrls, Dialogs, Forms,
     WinTypes, WinProcs, Messages;

{TJetCheckBoxEditor}

Type
  TJetCheckBoxEditor = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

  TJetButtonEditor = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

{TJetCheckBoxEditor}

procedure TJetCheckBoxEditor.Edit;
var
  Comp: TJetCheckBox;
  frm: TfrmJetCheckBoxEditor;
  W,H: Integer;
begin
  Comp:=(GetComponent(0) as TJetCheckBox);
  frm:=TfrmJetCheckBoxEditor.Create(nil);
  Try
    frm.Image1.Picture.Bitmap.Assign(Comp.BitmapChecked);
    frm.Image2.Picture.Bitmap.Assign(Comp.BitmapOverChecked);
    frm.Image3.Picture.Bitmap.Assign(Comp.BitmapDisabled);
    frm.Image4.Picture.Bitmap.Assign(Comp.BitmapUnChecked);
    frm.Image5.Picture.Bitmap.Assign(Comp.BitmapOverUnChecked);
    frm.PictureRefresh;
    frm.Edit1.Text:=Comp.Caption;
    frm.FontD.Font.Assign(Comp.Font);
    frm.SEnabled.Down:= not Comp.Enabled;
    If Assigned(Comp.PicClip) then frm.PClip:=Comp.PicClip
    else frm.PClip:=nil;
    frm.FPicSeries:=Comp.PicSeries;
    IF frm.ShowModal = mrOK then begin
      W:=Comp.Width;
      H:=Comp.Height;
      Comp.BitmapChecked.Assign(frm.Image1.Picture.Bitmap);
      Comp.BitmapOverChecked.Assign(frm.Image2.Picture.Bitmap);
      Comp.BitmapDisabled.Assign(frm.Image3.Picture.Bitmap);
      Comp.BitmapUnChecked.Assign(frm.Image4.Picture.Bitmap);
      Comp.BitmapOverUnChecked.Assign(frm.Image5.Picture.Bitmap);
      IF Comp.Width<=2 then Comp.Width:=W;
      IF Comp.Height<=2 then Comp.Height:=H;
      Comp.Caption:=frm.Edit1.Text;
      Comp.Font.Assign(frm.FontD.Font);
      Comp.Enabled:=not frm.SEnabled.Down;
      Comp.Invalidate;
    end;
  Finally
    frm.Free;
  End;
end;

function TJetButtonEditor.GetAttributes: TPropertyAttributes;
begin
  Result:= [paDialog, paReadOnly];
end;

function TJetButtonEditor.GetValue: string;
begin
  Result:= '(Editor)';
end;

{TJetButtonEditor}

procedure TJetButtonEditor.Edit;
var
  Comp: TJetButton;
  frm: TfrmJetButtonEditor;
  W,H: Integer;
begin
  Comp:=(GetComponent(0) as TJetButton);
  frm:=TfrmJetButtonEditor.Create(nil);
  Try
    frm.IUp.Picture.Bitmap.Assign(Comp.BitmapUp);
    frm.IOver.Picture.Bitmap.Assign(Comp.BitmapOver);
    frm.IDown.Picture.Bitmap.Assign(Comp.BitmapDown);
    frm.IDisabled.Picture.Bitmap.Assign(Comp.BitmapDisabled);

    frm.PictureRefresh;
    frm.Edit1.Text:=Comp.Caption;
    frm.FontD.Font.Assign(Comp.Font);
    frm.SEnabled.Down:= not Comp.Enabled;
    frm.Refresh;
    If Assigned(Comp.PicClip) then frm.PClip:=Comp.PicClip
    else frm.PClip:=nil;
    frm.FPicSeries:=Comp.PicSeries;
    IF frm.ShowModal = mrOK then begin
      W:=Comp.Width;
      H:=Comp.Height;
      Comp.BitmapUp.Assign(frm.IUp.Picture.Bitmap);
      Comp.BitmapOver.Assign(frm.IOver.Picture.Bitmap);
      Comp.BitmapDown.Assign(frm.IDown.Picture.Bitmap);
      Comp.BitmapDisabled.Assign(frm.IDisabled.Picture.Bitmap);
      IF Comp.Width<=2 then Comp.Width:=W;
      IF Comp.Height<=2 then Comp.Height:=H;
      Comp.Caption:=frm.Edit1.Text;
      Comp.Font.Assign(frm.FontD.Font);
      Comp.Enabled:=not frm.SEnabled.Down;
      Comp.Invalidate;
    end;
  Finally
    frm.Free;
  End;
end;

function TJetCheckBoxEditor.GetAttributes: TPropertyAttributes;
begin
  Result:= [paDialog, paReadOnly];
end;

function TJetCheckBoxEditor.GetValue: string;
begin
  Result:= '(Editor)';
end;


procedure Register;
begin
  RegisterComponents('Jet', [TJetCheckBox]);
  RegisterComponents('Jet', [TJetButton]);
  RegisterComponents('Jet', [TJetAnimButton]);
  RegisterPropertyEditor(TypeInfo(String), TJetCheckBox, 'BitmapEditor', TJetCheckBoxEditor);
  RegisterPropertyEditor(TypeInfo(String), TJetButton, 'BitmapEditor', TJetButtonEditor);
end;

end.
